<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"forums"
	);

	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action", "id", "return");

	// privileges to edit messages
	$auth_edit = is_admin();

	if (!$auth_edit && $id) {
		$db->query("SELECT id, creationtime, userid
		FROM ".db_table("forum_message")." WHERE id = '{$id}'");
		$row = $db->fetch_row();
		$auth_edit = forums::messageAuthEdit($id, $row["creationtime"], $row["userid"]);
	}

	// setting antiflood rule
	$forum_antiflood = $AccessTable->set_generic_rule("forum", "post");

	if (is_admin()) {
		switch ($action) {
			case "category_delete":

				varRequire("id");
				forums::deleteItem($id);

			break;
			case "category_enable":

				varRequire("id");
				$db->query("UPDATE ".db_table("forum_category")."
				SET status='1' WHERE id='{$id}'", __FILE__, __LINE__);

			break;
			case "forum_enable":

				varRequire("id");
				$db->query("UPDATE ".db_table("forum_forum")."
				SET status='1' WHERE id='{$id}'", __FILE__, __LINE__);

			break;
			case "category_move":

				varImport("where");

				varRequire("id", "where");

				// fetching immediatly lower or higher item
				$w = ($where == "up") ? "<" : ">";

				$db->query("SELECT orderid FROM ".db_table("forum_category")." WHERE id = '{$id}'");

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					$db->query("SELECT id, orderid FROM ".db_table("forum_category")."
					WHERE orderid $w '{$row["orderid"]}'
					ORDER BY orderid ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);

					if ($db->num_rows()) {

						$row2 = $db->fetch_row();

						// swapping order
						$db->query("UPDATE ".db_table("forum_category")." SET
							orderid = '{$row2["orderid"]}'
						WHERE id = '{$id}'");

						$db->query("UPDATE ".db_table("forum_category")." SET
							orderid = '{$row["orderid"]}'
						WHERE id = '{$row2["id"]}'");

						slog("forums: category '$id' moved", "actions", 2);
					}

				}
			break;
			case "forum_move":

				varImport("id", "where");

				varRequire("id", "where");

				$w = ($where == "up") ? "<" : ">";

				$db->query("SELECT categoryid, orderid FROM ".db_table("forum_forum")." WHERE id = '$id'");

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					$db->query("SELECT id, orderid FROM ".db_table("forum_forum")."
					WHERE categoryid = '{$row["categoryid"]}' AND orderid $w '{$row["orderid"]}'
					ORDER BY orderid ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);

					if ($db->num_rows()) {
						$row2 = $db->fetch_row();

						// swapping orderid
						$db->query("UPDATE ".db_table("forum_forum")." SET
							orderid = '{$row2["orderid"]}'
						WHERE id = '{$id}'");

						$db->query("UPDATE ".db_table("forum_forum")." SET
							orderid = '{$row["orderid"]}'
						WHERE id = '{$row2["id"]}'");

						slog("forums: forum '$id' moved", "actions", 2);
					}
				}

			break;
			case "forum_delete":
				varRequire("id");
				forums::deleteForum($id);
			break;
			case "thread_delete":

				$db->query("SELECT t.forumid, f.categoryid
				FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")." f
				WHERE t.id = '{$id}' AND t.forumid = f.id", __FILE__, __LINE__);

				$row = $db->fetch_row();

				if ($db->num_rows()) {
					forums::deleteThread($id);
					$return = urlEvalPrototype("index.php/module=forums?path={$row["categoryid"]}.{$row["forumid"]}", true, false);
				}

				forums::updateForumStats($id);
			break;
			case "thread_move":

				varImport("to");

				varRequire("id", "to");

				$db->query("SELECT f.id, f.categoryid
				FROM ".db_table("forum_category")." c, ".db_table("forum_forum")." f, ".db_table("forum_thread")." t
				WHERE t.id = '{$id}' AND f.categoryid = c.id AND t.forumid = f.id",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();

					$db->query("UPDATE ".db_table("forum_thread")." SET forumid = '{$to}'
					WHERE id = '{$id}'", __FILE__, __LINE__);

					forums::updateForumStats($to);
					forums::updateForumStats($row["id"]);

					$return = urlEvalPrototype("index.php/module=forums?path={$row["categoryid"]}.$to", true, false);

					slog("forums: moved thread '$id' to forum '$to'", "actions", 1);
				}
			break;
			case "thread_mode":

				varImport("mode");

				varRequire("id", "mode");

				unset ($mode_field, $mode_value);

				switch ($mode) {
					case "lock": case "unlock":
						$mode_field = "mode_locked";
						$mode_value = ($mode == "lock");
					break;
					case "stick": case "unstick":
						$mode_field = "mode_sticked";
						$mode_value = ($mode == "stick");
					break;
				}

				if (isset($mode_field)) {
					$db->query("UPDATE ".db_table("forum_thread")."
					SET $mode_field = '$mode_value' WHERE id = '$id'", __FILE__, __LINE__);

					$db->query("SELECT t.forumid, f.categoryid
					FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")." f
					WHERE t.id = '{$id}' AND t.forumid = f.id", __FILE__, __LINE__);
					$row = $db->fetch_row();

					$return = urlEvalPrototype("index.php/forums?path={$row["categoryid"]}.{$row["forumid"]}", true, false);

					slog("forums: thread mode changed '$id'", "actions", 1);
				}

			break;
			case "category_edit":

				varImport("id", "icon", "status", "orderid", "name", "description", "auth_access", "auth_post");

				requireVars($id, $name);

				table_simpleSwitchOrder("forum_category", $id, $orderid);

				$db->query ("
				UPDATE ".db_table("forum_category")." SET
					orderid = '{$orderid}',
					icon = '{$icon}',
					name = '{$name}',
					description = '{$description}',
					status = '{$status}',
					auth_access = '{$auth_access}',
					auth_post = '{$auth_post}'
				WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified category id='$id'", "actions", 1);

			break;
			case "forum_edit":

				varImport("id", "icon", "status", "categoryid", "orderid", "name", "description");

				requireVars($id, $categoryid, $name);

				table_simpleSwitchOrder("forum_forum", $id, $orderid);

				// inserting into database
				$db->query ("
				UPDATE ".db_table("forum_forum")." SET
					categoryid = '{$categoryid}',
					orderid = '{$orderid}',
					icon = '{$icon}',
					name = '{$name}',
					description = '{$description}',
					status = '{$status}'
				WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified forum id='$id'", "actions", 1);
			break;
			case "category_create":

				varImport("icon", "status", "orderid", "name", "description", "auth_access", "auth_post");

				requireVars($name);

				// assigning order id
				$db->query ("SELECT orderid FROM ".db_table("forum_category")."
				ORDER BY orderid ".(($orderid) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$orderid = $row["orderid"] + ($orderid ? 1 : -1);
				} else {
					$orderid = 1;
				}

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_category")."
					(
						id,
						orderid,
						icon,
						name,
						description,
						status,
						auth_access,
						auth_post
					)
						VALUES
					(
						'".$db->free_id("forum_category")."',
						'{$orderid}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'{$status}',
						'{$auth_access}',
						'{$auth_post}'
					)
				", __FILE__, __LINE__);

				// saving preferences
				conf::setkey("forums", "default_auth_access", $auth_access, "s");
				conf::setkey("forums", "default_auth_post", $auth_post, "s");

				slog("forums: created category '$name'", "actions", 1);

			break;
			case "forum_create":
				varImport("icon", "status", "categoryid", "orderid", "name", "description");

				requireVars($name, $categoryid);

				$db->query ("SELECT orderid FROM ".db_table("forum_forum")."
				ORDER BY orderid ".(($orderid) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$orderid = $row["orderid"] + ($orderid ? 1 : -1);
				} else {
					$orderid = 1;
				}

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_forum")."
					(
						id,
						categoryid,
						orderid,
						icon,
						name,
						description,
						messagecount,
						topiccount,
						lastpostid,
						status
					)
						VALUES
					(
						'".$db->free_id("forum_forum")."',
						'{$categoryid}',
						'{$orderid}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'0',
						'0',
						'0',
						'{$status}'
					)
				", __FILE__, __LINE__);

				slog("forums: created forum '$name'", "actions", 1);
			break;
		}
	}

	switch ($action) {
		case "message_delete":
			if (is_admin() || $auth_edit) {

				varRequire("id");

				$db->query("SELECT topicid, is_topic
				FROM ".db_table("forum_message")."
				WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					if ($row["is_topic"]) {
						// this message is also a topic, so if we require to
						// delete this message, all messages linked to this
						// topic will be deleted too.

						$db->query("SELECT id FROM ".db_table("forum_message")."
						WHERE topicid = '{$row["topicid"]}'", __FILE__, __LINE__);

						if (!is_admin() && $db->num_rows()) {

							// an ordinary user cannot delete topics
							abort(accessDenied());

						} elseif (is_admin()) {
							// admin can delete topics

							$db->query("DELETE FROM ".db_table("forum_message")."
							WHERE topic = '{$row["topicid"]}' OR id = '{$id}'");

							$db->query("DELETE FROM ".db_table("forum_thread")."
							WHERE id = '{$id}'", __FILE__, __LINE__);

							$return = urlEvalPrototype("index.php/module=forums", true, false);

							forums::updateThreadStats($row["topicid"]);

						}
					} else {
						// deleting message
						$db->query("DELETE FROM ".db_table("forum_message")."
						WHERE id = '{$id}' ".(is_admin() ? "" : "AND userid = '{$row["userid"]}'")."",
						__FILE__, __LINE__);
					}

				}

				slog("forums: deleted message '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}
		break;
		case "message_edit":

			varImport("id", "category", "forum", "thread", "nickname", "email", "topic", "icon", "content");

			requireVars($id, $category, $forum, $thread, $topic, $content);

			$auth = forums::checkAuth($category, $forum, $thread);

			if ($auth_edit && $auth["post"]) {
				$db->query("
				UPDATE ".db_table("forum_message")." SET
					".($nickname ? "nickname = '{$nickname}',": "")."
					".($email ? "contactmail = '{$email}',": "")."
			    	icon = '{$icon}',
					title = '{$topic}',
					content = '{$content}'
				WHERE id = '{$id}' AND Topicid = '{$thread}' ".(is_admin() ? "" : " AND userid = '{$USER["id"]}'")."
				", __FILE__, __LINE__);

				slog("forums: edited message '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}

		break;
		case "topic_reply":

			// preventing flood
			$AccessTable->load_rule($forum_antiflood, "E_ANTI_FLOOD");

			varImport("category", "forum", "thread", "nickname", "email", "topic", "icon", "content");

			requireVars($category, $forum, $thread, $topic, $content);

			$auth = forums::checkAuth($category, $forum, $thread);

			if ($auth["reply"]) {

				$db->query("
				INSERT INTO ".db_table("forum_message")." (
					id,
					topicid,
					icon,
					title,
					content,
					creationtime,
					is_topic,
					nickname,
					contactmail,
					userid
				) VALUES (
					'".($msg = $db->free_id("forum_message"))."',
					'{$thread}',
					'{$icon}',
					'{$topic}',
					'{$content}',
					'".time()."',
					'0',
					'{$nickname}',
					'{$email}',
					'{$USER["id"]}'
				)",
				__FILE__, __LINE__);

				forums::updateThreadStats($thread);

				$return = urlEvalPrototype("index.php/module=forums?path={$category}.{$forum}.{$thread}&page=last#{$msg}", true, false);

				slog("forums: thread replied '$id'", "actions", 2);
			}
		break;
		case "topic_create":

			// antiflood
			$AccessTable->load_rule($forum_antiflood, _l("E_ANTI_FLOOD"));

			varImport("category", "forum", "nickname", "email", "topic", "icon", "content");

			varRequire("category", "forum", "topic", "content");

			$auth = forums::checkAuth($category, $forum);

			if ($auth["post"]) {

				$thread = $db->free_id("forum_thread");

				$db->query("INSERT INTO ".db_table("forum_thread")." (
						id,
						forumid,
						stat_reads,
						stat_replies,
						mode_locked,
						mode_sticked
					) VALUES (
						'{$thread}',
						'{$forum}',
						'0',
						'0',
						'0',
						'0'
					)
				", __FILE__, __LINE__);

				$db->query("INSERT INTO ".db_table("forum_message")." (
						id,
						topicid,
						icon,
						title,
						content,
						creationtime,
						is_topic,
						nickname,
						contactmail,
						userid
					) VALUES (
						'".$db->free_id("forum_message")."',
						'{$thread}',
						'{$icon}',
						'{$topic}',
						'{$content}',
						'".time()."',
						'1',
						'{$nickname}',
						'{$email}',
						'{$USER["id"]}'
					)", __FILE__, __LINE__);

					forums::updateThreadStats($id);

					$return = urlEvalPrototype("index.php/module=forums?path={$category}.{$forum}.{$thread}", true, false);

					slog("forums: new forum thread '$id'", "actions", 2);
			} else {
				abort(accessDenied());
			}

		break;
	}

	redirect($return);

	db_exit();
?>