<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"forums"
	);

	Extract (
		URLGetArgs ("null/action=alpha?path=string&page=page")
	);

	$catid = $frmid = $tpcid = $msgid = 0;

	if ($path) {
		$path = explode(".", preg_replace("/[^0-9\.]/", "", $path));
		if (isset($path[0])) $catid = $path[0];
		if (isset($path[1])) $frmid = $path[1];
		if (isset($path[2])) $tpcid = $path[2];
		if (isset($path[3])) $msgid = $path[3];
	}

	function array_key_prefix(&$arr, $prefix) {
		$buff = Array();
		foreach ($arr as $i => $t)
			$buff[$prefix.strtoupper($i)] = $t;
		$arr = $buff;
	}

	$allowed_categories = forums::getAllowedCategories();

	if ($catid && $frmid) {

		// FORUM VIEW
		forums::updateForumStats($frmid);

		$forum_auth = forums::checkAuth($catid, $frmid);

		// let's have a catid check before this
		if (in_array($catid, $allowed_categories) && $forum_auth["view"]) {

			// gathering generic information
			$db->query("SELECT id, name, icon FROM ".db_table("forum_category")."
			WHERE id = '{$catid}'", __FILE__, __LINE__);

			if ($db->num_rows()) {
				$category = $db->fetch_row();
				saneHTML($category);
				array_key_prefix($category, "CATEGORY_");
			} else {
				abort(header("Location: ".urlevalprototype("index.php/module=forums&message="._l("L_UNEXISTENT_CATEGORY")."&type=error", true, false)));
			}

			$db->query("SELECT id,name, icon FROM ".db_table("forum_forum")."
			WHERE id = '{$frmid}'", __FILE__, __LINE__);

			if ($db->num_rows()) {
				$forum = $db->fetch_row();
				saneHTML($forum);
				array_key_prefix($forum, "FORUM_");
			} else {
				abort(header("Location: ".urlevalprototype("index.php/module=forums&path={$catid}&message="._l("L_UNEXISTENT_FORUM")."&type=error", true, false)));
			}

			if ($tpcid) {
				// TOPIC

				$topic_auth = forums::checkAuth($catid, $frmid, $tpcid);

				$db->query("SELECT t.id, m.title, m.icon
				FROM ".db_table("forum_message")." m, ".db_table("forum_thread")." t
				WHERE m.is_topic = '1' AND m.topicid = '{$tpcid}' and t.id='$tpcid'",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$topic = $db->fetch_row();
					saneHTML($topic);
					array_key_prefix($topic, "TOPIC_");
				} else {
					abort(header("Location: ".urlevalprototype("index.php/module=forums&path={$catid}.{$frmid}&message=".urlencode(_L("L_UNEXISTENT_TOPIC"))."&type=error", true, false)));
				}

				switch ($action) {
					case "topic_reply":

						if ($topic_auth["reply"]) {

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

							$tpl->set_arr ($category);
							$tpl->set_arr ($forum);
							$tpl->set_arr ($topic);

							$tpl->set_arr (
								Array (
									"BLOCK_TITLE"	=> _l("L_REPLY"),
									"BLOCK_ICON"	=> mkIcon("forums.png", 16),
									"NICKNAME"		=> "",
									"TITLE"			=> "Re: ".$topic["TOPIC_TITLE"],
									"ICON"			=> $topic["TOPIC_ICON"],
									"CONTACTMAIL"	=> "",
									"CONTENT"		=> "",
									"RETURN"		=> "index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}",
									"ACTION"		=> "topic_reply",
								)
							);

							// messages summary
							$db->query("SELECT icon, title, content, creationtime,
							userid, nickname, contactmail
							FROM ".db_table("forum_message")."
							WHERE topicid = '{$tpcid}'
							ORDER BY creationtime ASC", __FILE__, __LINE__);

							while ($row = $db->fetch_row()) {

								saneHTML($row, "content");

								Format::Style($row["content"], $row["userid"]);

								$row["author"] = forums::mkuserlink($row);

								$tpl->set_arr($row, "MESSAGE");
								$tpl->savebuff("MESSAGE");
							}

							$mcBuff = $tpl->make();

						} else {
							$mcBuff = accessDenied();
						}
					break;
					default:
						if ($msgid) {
							switch ($action) {
								case "message_edit":

									$tpl = new ContentBlock();
									$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

									// message
									$db->query("SELECT id, title, icon, content, nickname, contactmail,
									userid
									FROM ".db_table("forum_message")."
									WHERE id = '{$msgid}' AND topicid = '{$tpcid}'
									", __FILE__, __LINE__);

									$row = $db->fetch_row();
									saneHTML($row, "content");

									$filter = new GekkoHtmlFilter(cache_func("Users::fetchInfo", $row["userid"], "groups"));
									$row["content"] = $filter->applyFilters($row["content"]);

									$tpl->set_arr ($category);
									$tpl->set_arr ($forum);
									$tpl->set_arr ($topic);

									$tpl->set_arr($row);
									$tpl->set_arr (
										Array (
											"BLOCK_TITLE"	=> _l("L_EDIT_MESSAGE"),
											"BLOCK_ICON"	=> mkIcon("forums.png", 16),
											"ACTION"		=> "message_edit",
											"RETURN"		=> local_referer()."#{$msgid}"
										)
									);

									$mcBuff = $tpl->make();

								break;
								default:
									// PERMALINK

									$db->query("SELECT creationtime FROM ".db_table("forum_message")."
									WHERE id='{$msgid}'", __FILE__, __LINE__);

									if ($db->num_rows()) {

										$row = $db->fetch_row();

										$db->query("SELECT id FROM ".db_table("forum_message")."
										WHERE topicid = '{$tpcid}' AND creationtime < '{$row["creationtime"]}'",
										__FILE__, __LINE__);

										$page = ($db->num_rows()+1)/conf::getKey("forums", "messages_per_page");

										if ($page > intval($page))
											$page = intval(++$page);

										abort(redirect(urlevalprototype("index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}&page=$page#$msgid", true, false)));

									} else {
										abort("Unknown permalink.");
									}

								break;
							}
						} else {
							// (no $msgid)

							// TOPIC VIEWING

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/thread.tpl");

							$pager = $db->pager(
								"SELECT id FROM ".db_table("forum_message")." WHERE
								topicid = '{$tpcid}'",
								"index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}&page=%p",
								$page, conf::getKey("forums", "messages_per_page")
							);

							// listing messages
							$db->query("SELECT
							id, icon, title, content, creationtime, nickname, contactmail, userid
							FROM ".db_table("forum_message")."
							WHERE topicid = '{$tpcid}'
							ORDER BY creationtime ASC {$pager["sql"]}", __FILE__, __LINE__);

							// updating statistics
							$db->query("UPDATE ".db_table("forum_thread")." SET
							stat_reads = stat_reads + 1
							WHERE id = '{$tpcid}'", __FILE__, __LINE__, true);

							while ($row = $db->fetch_row()) {

								saneHTML($row, "content");

								Format::Style($row["content"], $row["userid"]);

								$row["author"] = forums::mkUserLink($row);

								$row["ACTIONS"] = new tplButtonBox();
								if (forums::messageAuthEdit($row["id"], $row["creationtime"], $row["userid"])) {
									$row["ACTIONS"]->add(mklink("index.php/module=forums/action=message_edit?path={$catid}.{$frmid}.{$tpcid}.{$row["id"]}", _l("L_EDIT"), "edit.png"));
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=message_delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
								}
								$row["ACTIONS"] = $row["ACTIONS"]->make();

								$tpl->set_arr($row, "MESSAGE");
								$tpl->savebuff("MESSAGE");
							}

							$db->query("SELECT mode_locked, mode_sticked
								FROM ".db_table("forum_thread")."
								WHERE id = '{$tpcid}'", __FILE__ , __LINE__);
							$row = $db->fetch_row();
							saneHTML($row);

							$row["ACTIONS"] = new tplButtonBox();

							if ($topic_auth["reply"])
								$row["ACTIONS"]->add(mklink("index.php/module=forums/action=topic_reply?path={$catid}.{$frmid}.{$tpcid}", _l("L_REPLY"), "reply.png"));

							if (gauth("admin")) {
								// code below used to be difficult to read...

								if ($row["mode_locked"])
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_mode&mode=unlock&id={$tpcid}&auth={C_AUTH_STR}", _l("L_UNLOCK_THREAD"), "unlock.png"));
								else
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_mode&mode=lock&id={$tpcid}&auth={C_AUTH_STR}", _l("L_LOCK_THREAD"), "lock.png"));

								if ($row["mode_sticked"])
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_mode&mode=unstick&id={$tpcid}&auth={C_AUTH_STR}", _l("L_UNSTICK_THREAD"), "unstick.png"));
								else
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_mode&mode=stick&id={$tpcid}&auth={C_AUTH_STR}", _l("L_STICK_THREAD"), "stick.png"));

								$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_delete&id={$tpcid}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));

								$tpl->set (
									"CATEGORIES.SEL",
										mkSelect (
											forums::getForums(),
											$frmid,
											"category",
											"onchange=\"confirmAction('".urlevalprototype("modules/forums/main.act.php?action=thread_move&id={$tpcid}&to='+this.value+'&auth="._l("C_AUTH_STR")."'", true, false).", '"._l("L_MOVE_TOPIC")."')\""
										)
								);
							}
							$row["ACTIONS"] = $row["ACTIONS"]->make();

							$tpl->set_arr($forum);
							$tpl->set_arr($category);
							$tpl->set_arr($topic);
							$tpl->set_arr($row);

							$tpl->set_arr (
								Array (
									"BLOCK_TITLE"		=> $topic["TOPIC_TITLE"],
									"BLOCK_ICON"		=> mkicon($topic["TOPIC_ICON"]),
									"PAGER"				=> $pager["html"],
									"RETURN"			=> ""
								)
							);

							$mcBuff = $tpl->make();

						} // end of thread
					break;
				}
			} else {
				// (no topic id)
				switch ($action) {
					case "topic_create":
						// TOPIC CREATION
						if ($forum_auth["post"]) {

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

							$rtb = new rtbEditor();
							$rtb->setSize(350, 150);

							$tpl->set_arr (
								Array (
									"BLOCK_TITLE"	=> _l("L_NEW_TOPIC"),
									"BLOCK_ICON"	=> mkIcon("forums.png", 16),
									"ICON"			=> "forums.png",
									"NICKNAME"		=> "",
									"CONTACTMAIL"	=> "",
									"TITLE"			=> "",
									"RTBEDITOR"		=> $rtb->make(),
									"RETURN"		=> "",
									"ACTION"		=> "topic_create"
								)
							);

							$tpl->set_arr($category);
							$tpl->set_arr($forum);

							$mcBuff = $tpl->make();
						} else {
							$mcBuff = accessDenied();
						}
					break;
					default:
						// THREAD VIEW
						$tpl = new ContentBlock();
						$tpl->insert("BLOCK_CONTENT", "forums/forum.tpl");

						$pager = $db->pager(
							"SELECT id FROM ".db_table("forum_thread")." WHERE
							forumid = '{$frmid}'",
							"index.php/module=forums?path={$catid}.{$frmid}&page=%p",
							$page, conf::getKey("forums", "threads_per_page")
						);

						// topic related to this category
						$db->query("SELECT
						t.id, t.stat_reads, t.stat_replies, t.mode_sticked, t.mode_locked, m.icon,
						m.title, m.creationtime,
						m.nickname, m.userid
						FROM ".db_table("forum_thread")." t, ".db_table("forum_message")." m
						WHERE t.forumid = '{$frmid}' AND m.topicid = t.id AND m.is_topic = '1'
						ORDER BY t.mode_sticked DESC, m.creationtime DESC {$pager["sql"]}",
						__FILE__, __LINE__);

						while ($row = $db->fetch_row()) {
							saneHTML($row);

							// last message for this topic
							$q = $db->query("SELECT title, nickname, contactmail, userid,
							creationtime
							FROM ".db_table("forum_message")."
							WHERE topicid = '{$row["id"]}'
							ORDER BY creationtime DESC LIMIT 1",
							__FILE__, __LINE__, true);

							while ($row2 = $db->fetch_row($q)) {
								saneHTML($row2);
								$tpl->reset("TOPIC.STATS");

								$row2["LAST_AUTHOR"] = forums::mkUserLink($row2);

								$tpl->set_arr($row2, "TOPIC.STATS");
								$tpl->saveBuff("TOPIC.STATS");
							}

							$tpl->set_arr($category, "TOPIC");
							$tpl->set_arr($forum, "TOPIC");

							$tpl->set_arr($row, "TOPIC");
							$tpl->savebuff("TOPIC");
						}

						// actions
						$actions = new tplButtonBox();
						if ($forum_auth["post"]) {
							$actions->add(mklink("index.php/module=forums/action=topic_create?path={$catid}.{$frmid}", _l("L_NEW_TOPIC"), "new.png"));
						}

						$tpl->set_arr($category);
						$tpl->set_arr($forum);

						$tpl->set_arr (
							Array (
								"BLOCK_TITLE"		=> _l("L_VIEW_FORUM"),
								"BLOCK_ICON"		=> mkicon($forum["FORUM_ICON"]),
								"ACTIONS"			=> $actions->make(),
								"PAGER"				=> $pager["html"]
							)
						);

						$mcBuff = $tpl->make();
					break;
				}
			}
		} else {
			$mcBuff = accessDenied();
		}
	} else {

		// SHOWING A LIST OF FORUMS INSIDE CATEGORIES
		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "forums/index.tpl");

		// querying for categories
		$db->query("SELECT id, icon, name, description
		FROM ".db_table("forum_category")."
		WHERE (".forums::getAllowedCategories(true, "id").") ".($catid ? "AND id = '{$catid}'" : "")."
		ORDER BY orderid ASC",
		__FILE__, __LINE__);

		while ($row = $db->fetch_row()) {
			saneHTML($row);

			// listing forums for this category
			$q = $db->query("SELECT id, icon, categoryid, name, description,
			messagecount, topiccount, lastpostid
			FROM ".db_table("forum_forum")."
			WHERE categoryid = '{$row["id"]}' AND status = '1'
			ORDER BY orderid ASC",
			__FILE__, __LINE__, true);

			$tpl->reset("CATEGORY.FORUM");

			if ($db->num_rows()) {

				while ($row2 = $db->fetch_row($q)) {

					saneHTML($row2);

					$p = $db->query("SELECT id, topicid, title, creationtime,
					userid, nickname, contactmail
					FROM ".db_table("forum_message")."
					WHERE id = '{$row2["lastpostid"]}'", __FILE__, __LINE__, true);

					if ($db->num_rows($p)) {
						$tpl->reset("CATEGORY.FORUM.STATS");

						$row3 = $db->fetch_row($p);
						saneHTML($row3);

						$tpl->set_arr (
							Array (
								"LAST_TOPIC"	=> mkLink("index.php/module=forums?path={$row["id"]}.{$row2["id"]}.{$row3["topicid"]}?page=last#{$row3["id"]}", $row3["title"]),
								"LAST_AUTHOR"	=> forums::mkuserlink($row3),
								"LAST_DATE"		=> dateFormat($row3["creationtime"])
							)
						, "CATEGORY.FORUM.STATS");

						$tpl->saveBuff("CATEGORY.FORUM.STATS");
					}
					$row2["STATUS_ICON"] = "open.png";

					$tpl->set_arr($row2, "CATEGORY.FORUM");
					$tpl->savebuff("CATEGORY.FORUM");
				}

				$tpl->set_arr($row, "CATEGORY");

				$tpl->savebuff("CATEGORY");
			}

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_SUBTITLE"	=> _l("L_CATEGORIES_INDEX"),
					"BLOCK_ICON"		=> mkicon("forums.png")
				)
			);

			$mcBuff = $tpl->make();
		}
	}

?>